org.cpsolver.ifs.heuristics

## Interface NeighbourSelection<V extends Variable<V,T>,T extends Value<V,T>>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Known Implementing Classes:
    AssignInitialSelection, BacktrackNeighbourSelection, BacktrackSelection, BranchBoundSelection, CriticalBacktrackSelection, CriticalCoursesBranchAndBoundSelection, CriticalStandardSelection, ExamColoringConstruction, ExamConstruction, ExamGreatDeluge, ExamHillClimbing, ExamNeighbourSelection, ExamPeriodSwapMove, ExamRandomMove, ExamRoomMove, ExamSimulatedAnnealing, ExamSplitMoves, ExamTabuSearch, ExamTimeMove, FixCompleteSolutionNeighbourSelection, GreatDeluge, HillClimber, MaxIdleNeighbourSelection, MetaHeuristicSearch, MinCreditBranchAndBoundSelection, NeighbourSearch, NeighbourSelectionWithContext, NeighbourSelectionWithSuggestions, NeighbourSelector, OnlineSelection, ParallelConstruction, PriorityConstructionSelection, RandomizedBacktrackNeighbourSelection, RandomMove, RandomStudentSwap, RandomSwapMove, RandomUnassignmentSelection, ResectionIncompleteStudentsSelection, ResectionUnassignedStudentsSelection, RestoreBestSolution, RndUnProblStudSelection, RoomChange, RoomSwap, RoundRobinNeighbourSelection, ShuffleStudentsSelection, ShuffleStudentsSelection.ShuffleBacktrackNeighbourSelection, SimpleSearch, SimulatedAnnealing, StandardNeighbourSelection, StandardSelection, StepCountingHillClimber, StudentEnrollmentSwapSelection, StudentSctNeighbourSelection, StudentSwapGenerator, Suggestion, SuggestionMove, SuggestionSelection, SwapStudentSelection, TimeChange, TimeSwap, TwoPhaseStudentSctNeighbourSelection, TwoPhaseStudentSctNeighbourSelection.RestoreDummyStudents

      public interface NeighbourSelection<V extends Variable<V,T>,T extends Value<V,T>>

  Neighbour selection criterion.
  In each iteration of the solver, a neighbour is selected and assigned (by default `StandardNeighbourSelection` is employed).
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  Author:
    Tomáš Müller
  See Also:
    `Solver`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<V,T> solver)` Criterion initialization
    `Neighbour<V,T>` | `selectNeighbour(Solution<V,T> solution)` select a neighbour of a given solution

- - ### Method Detail

    - #### init

          void init(Solver<V,T> solver)

      Criterion initialization
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          Neighbour<V,T> selectNeighbour(Solution<V,T> solution)

      select a neighbour of a given solution
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment